// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------
// CircleAverageDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include <complex>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCircleAverageDlg _CAO

CCircleAverageDlg::CCircleAverageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCircleAverageDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCircleAverageDlg)
	m_searchmode = -1;
	m_precision = -1;
	m_condition = 5;
	m_threshold = 60;
	m_middlethreshold = 50;
	m_wndtouch = FALSE;
	m_checkcircleradius = 5;
	m_checkcircleanglepitch = 20;
	m_checktolerancelevel = 20;
	m_result = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_disp = NULL;
	m_blnVideoOpened = false;
}

void CCircleAverageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCircleAverageDlg)
	DDX_CBIndex(pDX, IDC_SEARCHMODE, m_searchmode);
	DDX_CBIndex(pDX, IDC_PRECISION, m_precision);
	DDX_Text(pDX, IDC_CONDITION, m_condition);
	DDV_MinMaxLong(pDX, m_condition, 1, 9);
	DDX_Text(pDX, IDC_THRESHOLD, m_threshold);
	DDV_MinMaxLong(pDX, m_threshold, 10, 99);
	DDX_Text(pDX, IDC_MIDDLETHRESHOLD, m_middlethreshold);
	DDV_MinMaxLong(pDX, m_middlethreshold, 10, 99);
	DDX_Check(pDX, IDC_WNDTOUCH, m_wndtouch);
	DDX_Text(pDX, IDC_CHECKCIRCLERADIUS, m_checkcircleradius);
	DDV_MinMaxLong(pDX, m_checkcircleradius, 0, 50);
	DDX_Text(pDX, IDC_CHECKCIRCLEANGLEPITCH, m_checkcircleanglepitch);
	DDV_MinMaxLong(pDX, m_checkcircleanglepitch, 0, 180);
	DDX_Text(pDX, IDC_CHECKTOLERANCELEVEL, m_checktolerancelevel);
	DDV_MinMaxLong(pDX, m_checktolerancelevel, 0, 255);
	DDX_Text(pDX, IDC_RESULT, m_result);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCircleAverageDlg, CDialog)
	//{{AFX_MSG_MAP(CCircleAverageDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SETPATTERN, OnSetpattern)
	ON_BN_CLICKED(IDC_DISPPATTERN, OnDisppattern)
	ON_BN_CLICKED(IDC_SETPATTERNMASK, OnSetpatternmask)
	ON_BN_CLICKED(IDC_SAVEPATTERN, OnSavepattern)
	ON_BN_CLICKED(IDC_LOADPATTERN, OnLoadpattern)
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_GSEARCHEXEREGION, OnGsearchexeregion)
	ON_BN_CLICKED(IDC_SETCIRCLE, OnSetcircle)
	ON_BN_CLICKED(IDC_SETCIRCLEBYPOINT, OnSetcirclebypoint)
	ON_BN_CLICKED(IDC_SETSTANDARD, OnSetstandard)
	ON_BN_CLICKED(IDC_EXECUTE, OnExecute)
	ON_BN_CLICKED(IDC_DOSAMPLE, OnDosample)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCircleAverageDlg bZ[W nh

BOOL CCircleAverageDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize( NULL );
		long err_no = 0;

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxImage1.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		m_FvxROI1.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxROI2.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxROI3.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxCorrelation.CreateInstance( __uuidof( FvxCorrelation ) ); 
		m_FvxPattern.CreateInstance( __uuidof( FvxPattern ) ); 
		m_GSearchExeRegion.CreateInstance( __uuidof( FvRectangle ) ); 
		m_OuterCircle.CreateInstance( __uuidof( FvCircle ) ); 
		m_StandardPoint.CreateInstance( __uuidof( FvPoint ) ); 
		m_SearchResult.CreateInstance( __uuidof( FvSearchResult ) ); 

		// J荞ݗL
		GetDlgItem( IDC_GRAB )->EnableWindow( FALSE );
		m_blnVideoOpened = false;

		// fBXvC
	    m_disp = new CDisplay();
		m_disp->Create( IDD_DISPLAY , GetDesktopWindow() );
		m_disp->ShowWindow( SW_HIDE );

		// fBXvC̏
		m_disp->m_FvxDisplayEx->CreateDisplay( 1 , 0 );

		// 摜̕\
		m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );

		// OCT[`͈͂̏lݒ(摜̑Sʂɐݒj
		m_GSearchExeRegion->Putxs( -1 );
		m_GSearchExeRegion->Putxe( -1 );
		m_GSearchExeRegion->Putys( -1 );
		m_GSearchExeRegion->Putye( -1 );

		// O~̏ݒ
	    m_OuterCircle->Putx( 200 );
		m_OuterCircle->Puty( 200 );
		m_OuterCircle->Putradius( 100 );

		// Rg[ނ̏
		CComboBox*    pcmb;
		
		pcmb = ( CComboBox* )GetDlgItem( IDC_SEARCHMODE );
		pcmb->AddString( "ʏ̃p^[" );
		pcmb->AddString( "̃p^[" );
		pcmb->AddString( "̃p^[" );
		pcmb->AddString( "sp^[" );
		m_searchmode = 0 ;

		pcmb = ( CComboBox* )GetDlgItem( IDC_PRECISION );
		pcmb->AddString( "ʏ퐸x" );
		pcmb->AddString( "x" );
		pcmb->AddString( "x" );
		m_precision = 0 ;
		
		UpdateData(FALSE); 
		
		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {
			
		    // rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ));

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();
				m_disp->ShowWindow( SW_SHOW );

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				m_disp->ShowWindow( SW_SHOW );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep( 350 );

			// GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            //i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize( m_FvxImage1 );

			try	{

				// 捞
				m_FvxVideo->GrabSync( m_FvxImage1 );

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem( IDC_GRAB )->EnableWindow( TRUE );
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;
		}

		m_disp->ShowWindow( SW_SHOW );
		UpdateData(FALSE); 
	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}
	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CCircleAverageDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CCircleAverageDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CCircleAverageDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


BOOL CCircleAverageDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}

// p^o^
void CCircleAverageDlg::OnSetpattern() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    
    // o^̏`ݒ
    IFvRectangle2Ptr pRect(__uuidof( FvRectangle ));

	pRect->Putxs( 100 );
    pRect->Putys( 100 );
    pRect->Putxe( 200 );
    pRect->Putye( 200 );
    
	m_FvxROI2->SetRectangle( pRect ) ;
    
    // FvxROIgď͈͑I_CAOo܂
    long lngOK = 0;
	m_FvxROI2->MakeROIDialog( m_FvxImage1, &lngOK );
    
    if (( lngOK == 1 ) && ( m_FvxROI2->GetCheckRectangle()==1 )) {
        m_FvxROI2->GetRectangle( pRect );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        double dblTemp = 0;
		if ( pRect->Getxe() < pRect->Getxs() ) {
            dblTemp = pRect->Getxs();
            pRect->Putxs( pRect->Getxe());
            pRect->Putxe( dblTemp );
		}
		if ( pRect->Getye() < pRect->Getys() ) {
            dblTemp = pRect->Getys();
            pRect->Putys( pRect->Getye() );
            pRect->Putye( dblTemp );
		}

	    // p^[_
		IFvPointPtr pPoint(__uuidof( FvPoint ));
			
        if ( m_FvxROI2->GetCheckPoint() == 1 ) {
            m_FvxROI2->GetPoint( pPoint );
		} else {
			MessageBox("p^[_w肳܂łB\r\np^[`̒S_Ƃēo^܂", "p^[o^" , MB_ICONWARNING | MB_OK );
            pPoint->Putx((pRect->Getxs() + pRect->Getxe()) / 2);
            pPoint->Puty((pRect->Getys() + pRect->Getye()) / 2);
		}
			
        m_FvxPattern->MakePattern( m_FvxImage1, pRect, pPoint );
	}
		
}

// p^[̕\
void CCircleAverageDlg::OnDisppattern() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    m_FvxPattern->Disp( -1 , -1 );

}

// p^[̃}XNݒ
void CCircleAverageDlg::OnSetpatternmask() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_FvxPattern->DefMask( -1 , -1 );
}

// p^[t@C̕ۑ
void CCircleAverageDlg::OnSavepattern() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
	// "pat"gp邱Ƃ𐄏܂
	char szFilters[]="bitmap file(*.pat)|*.pat||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "pat", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		try {

			m_FvxPattern->PutSavePattrenFileName (_bstr_t( cFileDlg.GetPathName() ));
			m_FvxPattern->Save();
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxPattern->GetErrReport( &lngErr );
			cStr.Format("p^[ۑsBerr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
	
}

// p^[t@C̓Ǎ
void CCircleAverageDlg::OnLoadpattern() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    // p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
    //  "pat"gp邱Ƃ𐄏܂
	// R_CAONX̐
	char szFilters[]="pattern file(*.pat)|*.pat||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "pat", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		try {
		
			m_FvxPattern->PutLoadPattrenFileName( _bstr_t( cFileDlg.GetPathName() ));
			m_FvxPattern->Load();
			
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxPattern->GetErrReport( &lngErr );
			cStr.Format("p^[ǍݎsBerr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
	
}

// J摜荞
void CCircleAverageDlg::OnGrab() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
    m_FvxVideo->ChangeImageSize( m_FvxImage1 );
    
    // 捞
    m_FvxVideo->GrabSync( m_FvxImage1 );
    // 荞񂾉摜ʂɕ\
    m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );
		
}

// 摜t@CǍ
void CCircleAverageDlg::OnLoadimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){
		m_FvxFileAccess->PutFilePath( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImage1 );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		// 摜^Cv`FbN
		if (( m_FvxImage1->GetImageType ()!=imageGray ) || ( m_FvxImage1->GetBitPerPixel()!=8 )) {

			MessageBox("8bitOC̉摜ł͂܂","G[", MB_ICONWARNING | MB_OK);

            m_FvxImage1->PutBitPerPixel( 8 );
            m_FvxImage1->PutImageType( imageGray );
            m_FvxImage1->PutImageWidth( 512 );
            m_FvxImage1->PutImageHeight( 480 );

		}

        m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );

	}
	
}

// 摜t@Cۑ
void CCircleAverageDlg::OnSave() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImage1 );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

// OCT[`͈̏͂̐ݒ
void CCircleAverageDlg::OnGsearchexeregion() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    
    m_FvxROI1->SetRectangle( m_GSearchExeRegion );
    
    // FvxROIgď͈͑I_CAOo܂
    m_FvxROI1->PutUsePoint( FALSE );
	long lngOK = 0;
	m_FvxROI1->MakeROIDialog( m_FvxImage1, &lngOK );
    
    if (( lngOK == 1) && ( m_FvxROI1->GetCheckRectangle() == 1 )) {
        m_FvxROI1->GetRectangle( m_GSearchExeRegion );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        double dblTemp = 0;
		if ( m_GSearchExeRegion->Getxe() < m_GSearchExeRegion->Getxs() ) {
            dblTemp = m_GSearchExeRegion->Getxs();
            m_GSearchExeRegion->Putxs(  m_GSearchExeRegion->Getxe() );
            m_GSearchExeRegion->Putxe( dblTemp );
		}
		if ( m_GSearchExeRegion->Getye() < m_GSearchExeRegion->Getys() ){
            dblTemp = m_GSearchExeRegion->Getys();
            m_GSearchExeRegion->Putys( m_GSearchExeRegion->Getye() );
            m_GSearchExeRegion->Putye( dblTemp );
		}
	}	
}

// ROI_CAOɂ錟O~̐ݒ
void CCircleAverageDlg::OnSetcircle() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    m_FvxROI3->SetCircle( m_OuterCircle );
    
    // FvxROIgď͈͑I_CAOo܂
    m_FvxROI3->PutUseCircle( TRUE );
    m_FvxROI3->PutUseRectangle( FALSE );
    m_FvxROI3->PutUsePoint( FALSE );
    long lngOK;
	m_FvxROI3->MakeROIDialog( m_FvxImage1, &lngOK );
    
    if ( ( lngOK == 1 ) &&  ( m_FvxROI3->GetCheckCircle() == 1 )) {
        m_FvxROI3->GetCircle( m_OuterCircle );
        
        m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
        m_disp->m_FvxDisplayEx->PutPenColor( 0xFF0000 );
        m_disp->m_FvxDisplayEx->DrawData( 0, m_OuterCircle );
	}
		
}

// _w聕oXgɂ錟O~̐ݒ
void CCircleAverageDlg::OnSetcirclebypoint() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CSetCircleRobust SetCircleRobust;

	// oXgfBXvC
	SetCircleRobust.pFvxImageMain = m_FvxImage1;
	SetCircleRobust.DoModal();

	if ( SetCircleRobust.m_blnIsCircleSet == true ) {
		m_OuterCircle = SetCircleRobust.m_Circle;
	    m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
		m_disp->m_FvxDisplayEx->PutPenColor( 0xFF0000 );
	    m_disp->m_FvxDisplayEx->DrawData( 0, m_OuterCircle );
	}
}

// OCT[`si擾錋ʂ͂Pj
// p[^͐ݒ肵Ȃ̂ŁA炩ߔfĂƁB
bool CCircleAverageDlg::DoSearch()
{

	try {
	
		// p^[ݒ
		m_FvxCorrelation->SetPattern( m_FvxPattern );
        
		// T[`s
		long lngSearchedNum = 0;
		m_FvxCorrelation->Execute( m_FvxImage1, &lngSearchedNum );
    
		if ( lngSearchedNum > 0 ) m_FvxCorrelation->GetResult( 0, m_SearchResult );

		return true;

	} catch (_com_error) {

		long lngErr = 0 ;
		CString cStr;

		m_FvxCorrelation->GetErrReport( &lngErr );
		
		switch ( lngErr ) {
			case 0:
				cStr.Format("G[");
				break;
			case 5001:
				cStr.Format("p^݂Ă܂B err_no = %d", lngErr );
				break;
			case 5005:
				cStr.Format("p[^Ⴂ܂B err_no = %d", lngErr );
				break;
			case 5006:
				cStr.Format("^Ⴂ܂B err_no = %d", lngErr );
				break;
			case 5007:
				cStr.Format("p^摜̂߁Ao^ł܂B  err_no = %d", lngErr );
				break;
			case 5008:
				cStr.Format("p^ƃ}XÑTCYvĂ܂Berr_no = %d", lngErr );
				break;
			case 5009:
				cStr.Format("p[^NULLlw肳܂B err_no = %d", lngErr );
				break;
			case 5010:
				cStr.Format("̊mۂɎs܂B err_no = %d", lngErr );
				break;
			case 5022:
				cStr.Format("p^w肳Ă܂B err_no = %d", lngErr );
				break;
			default:
				cStr.Format("sȃG[ err_no = %d", lngErr );
				break;
		}

		MessageBox(cStr,"OCT[`G[", MB_ICONWARNING | MB_OK);
		return false;
	}
}

// _A(lng_x,lng_y)𒆐SƂ锼am_CheckCircleRadius̉~̓̕ϔZxl߂
long CCircleAverageDlg::CalcAverage(long lng_x, long lng_y)
{
	long xs = lng_x - m_CheckCircleRadius;
	long ys = lng_y - m_CheckCircleRadius;
	long xe = lng_x + m_CheckCircleRadius;
	long ye = lng_y + m_CheckCircleRadius;
        
    // NbsO
    if ( xs < 0 ) xs = 0;
    if ( ys < 0 ) ys = 0;
    if ( xe < 0 ) xe = 0;
    if ( ye < 0 ) ye = 0;
    if ( xs >= m_FvxImage1->GetImageWidth() )  xs = m_FvxImage1->GetImageWidth() - 1;
    if ( xe >= m_FvxImage1->GetImageWidth() )  xe = m_FvxImage1->GetImageWidth() - 1;
    if ( ys >= m_FvxImage1->GetImageHeight() ) ys = m_FvxImage1->GetImageHeight() - 1;
    if ( ye >= m_FvxImage1->GetImageHeight() ) ye = m_FvxImage1->GetImageHeight()- 1;
    
	IFvPointPtr pPoint(__uuidof( FvPoint ));
    long lngDensity = 0 ;
    long lngSum = 0 ;
    long lngCount = 0 ;
	for( long j = ys; j <= ye ; j++ ){
        for( long i = xs; i <= xe ; i++ ) {
            // ~̓H
            // (O̒藝ŉ~S̋߁AaƔrj
            if ( ((i - lng_x) * (i - lng_x) + (j - lng_y) * (j - lng_y)) <= ( m_CheckCircleRadius * m_CheckCircleRadius )) {
                pPoint->Putx( i );
                pPoint->Puty( j );
                m_FvxImage1->GetPixel( pPoint, &lngDensity, 0 );
                lngSum = lngSum + lngDensity ;
                lngCount = lngCount + 1 ;
			}
		}
	}

    // OZɂȂȂ悤Ƀ`FbN
    if ( lngCount > 0 ) {
        return lngSum / lngCount ;
	} else {
		return 0 ;
	}
}

// v
void CCircleAverageDlg::OnSetstandard() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    
    // p[^Kp
    if  ( !ApplyChanges() ) return ;
    
    // ʏ
    m_result = "";
    m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
    
    // `Fݒ
	m_disp->m_FvxDisplayEx->PutPenColor( 0xFF0000 );
	m_disp->m_FvxDisplayEx->PutFontColor( 0x0000FF );

    int intCount = 0;
    double x = 0;
    double y = 0;
	IFvCirclePtr pCheckCircle(__uuidof( FvCircle ));		// ~
	IFvPointPtr pPoint(__uuidof( FvPoint ));			    // Zxl擾p
    CString str;
	const double PI = 3.14159265358979;
	for ( long i = 0 ; i <= 360 ; i = i + m_CheckCirclePitch ) {
        
        // O~̓_vZ
		x = m_OuterCircle->Getx() + ( m_OuterCircle->Getradius() * cos(i * PI / 180));
        y = m_OuterCircle->Gety() + ( m_OuterCircle->Getradius() * sin(i * PI / 180));
        
        // ϔZxlZo
        m_StandardDensity[intCount] = CalcAverage(x, y);
        
        // ~\
        pCheckCircle->Putx( x );
        pCheckCircle->Puty( y );
        pCheckCircle->Putradius( m_CheckCircleRadius );
		m_disp->m_FvxDisplayEx->DrawData( 0, pCheckCircle );
        
        // Zxl\
        pPoint->Putx( x );
        pPoint->Puty( y );
		str.Format( "%d" , m_StandardDensity[intCount] );
		m_disp->m_FvxDisplayEx->DrawText( 0, pPoint , _bstr_t( str ) );
	    intCount++;
	}
		
    // OCT[`͈͂ŕ\
	m_disp->m_FvxDisplayEx->PutPenColor( 0xFF0000 );
	m_disp->m_FvxDisplayEx->DrawData( 0, m_GSearchExeRegion );
    
	IFvSearchResultPtr pSearchResult(__uuidof( FvSearchResult ));			    // OCT[`̌
	m_SearchResult = pSearchResult;
    // OCT[`̎s
    if ( DoSearch() ) {
		m_disp->m_FvxDisplayEx->DrawData( 0, m_SearchResult );
        
        // ̃T[`ʂACgƂĕۑ
        m_StandardPoint->Putx( m_SearchResult->Getx() );
        m_StandardPoint->Puty( m_SearchResult->Gety() );

	}
}

// ep[^̓Kp
bool CCircleAverageDlg::ApplyChanges()
{

	if( !UpdateData( TRUE )) return false;

    // OCT[`p[^ݒ
	m_FvxCorrelation->SetInspectArea( m_GSearchExeRegion );						 // ͈
    m_FvxCorrelation->PutSearchMode( (enum SEARCH_MODE_TYPE ) m_searchmode );    // T[`[hiׂȂǂ̃p^[Ɏgpj
    m_FvxCorrelation->PutPrecision( (enum PRECISION_TYPE ) m_precision);	     // T[`
    
    // 摜̏
    if ( ( m_condition < 1 ) || ( m_condition > 9 ) ) {
		MessageBox("摜Ԃ 1`9 ̊ԂŐݒ肵Ă","p[^G[", MB_ICONWARNING | MB_OK);
        return false;
	}
    m_FvxCorrelation->PutCondition( m_condition );
    
    // 臒l
    if ( ( m_threshold < 10 ) || ( m_threshold > 1000 ) ) {
		MessageBox("臒l 10`100 ̊Ԃœ͂Ă","p[^G[", MB_ICONWARNING | MB_OK);
        return false;
	}
	m_FvxCorrelation->PutScoreThresh( m_threshold );
    
    // r臒l
    if ( ( m_middlethreshold < 10 ) || ( m_middlethreshold > 1000 )) {
		MessageBox("r臒l 10`100 ̊Ԃœ͂Ă","p[^G[", MB_ICONWARNING | MB_OK);
        return false;
	}
	m_FvxCorrelation->PutScoreThresh2( m_middlethreshold );
    
    // T[`
    m_FvxCorrelation->PutSearchNum( 1 );
    
    // ͈͐ڐGĂ̂o邩
    if ( m_wndtouch ) {
        m_FvxCorrelation->PutWindowTouch( ( enum WINDOW_TOUCH_TYPE ) 1 );	// ON
	} else {
        m_FvxCorrelation->PutWindowTouch( ( enum WINDOW_TOUCH_TYPE ) 0 );	// OFF
	}

    // ϔZx

    // ~a
    if ( ( m_checkcircleradius < 0 ) || ( m_checkcircleradius > 50 )) {
		MessageBox("~a 0`50 ̊Ԃœ͂Ă","p[^G[", MB_ICONWARNING | MB_OK);
        return false;
	}
	m_CheckCircleRadius = m_checkcircleradius;

    // ~sb`
    if ( ( m_checkcircleanglepitch < 0 ) || ( m_checkcircleanglepitch > 180 )) {
		MessageBox("~sb` 0`180 ̊Ԃœ͂Ă","p[^G[", MB_ICONWARNING | MB_OK);
        return false;
	}
	m_CheckCirclePitch = m_checkcircleanglepitch;
    //ReDim Preserve m_StandardDensity(360 / lngTemp)
    
    // ǔ۔苖ei}j
    if ( ( m_checktolerancelevel < 0 ) || ( m_checktolerancelevel > 255 )) {
		MessageBox("ǔ۔苖e 0`255 ̊Ԃœ͂Ă","p[^G[", MB_ICONWARNING | MB_OK);
        return false;
	}
	m_CheckToleranceLevel = m_checktolerancelevel;

	return true;

}

// s
void CCircleAverageDlg::OnExecute() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
    
    // p[^Kp
    if ( !ApplyChanges() ) return;
    
    // ԌvJn
    m_FvxPerformanceCounter->StartCount();
    
    // OCT[`͈͂ŕ\
	m_disp->m_FvxDisplayEx->PutPenColor( 0xFF0000 );
	m_disp->m_FvxDisplayEx->DrawData( 0, m_GSearchExeRegion );
    
	IFvPointPtr pPoint(__uuidof( FvPoint ));						// Zxl擾p
	IFvCirclePtr pCheckCircle(__uuidof( FvCircle ));				// ~
    long x = 0, y= 0;												// ~S
    long lngCenterX = 0,lngCenterY = 0;								// ACgꂽO~S
    long lngDiffX = 0;												// XWY
    long lngDiffY = 0;											    // YWY
	const double PI = 3.14159265358979;
	CString str;
    int intCount = 0;												// ~ԍ
    long lngNGCount = 0;											// ڌ~̕ϔZxl
	long lngNowAveDensity = 0;										

	IFvSearchResultPtr pSearchResult(__uuidof( FvSearchResult ));			    // OCT[`̌
	m_SearchResult = pSearchResult;
	if ( DoSearch() ) {
        
        // T[`ʂԂŕ\
		m_disp->m_FvxDisplayEx->PutPenColor( 0x0000FF );
		m_disp->m_FvxDisplayEx->DrawData( 0, m_SearchResult );
        
        // ʒũYʌvZ
        lngDiffX = m_SearchResult->Getx() - m_StandardPoint->Getx();
        lngDiffY = m_SearchResult->Gety() - m_StandardPoint->Gety();

        m_result.Format("T[`W : ( %.2f , %.2f )\r\nYw : %d\r\nYx : %d\r\n" , m_SearchResult->Getx() , m_SearchResult->Gety() , lngDiffX , lngDiffY );

        // O~SACg
        lngCenterX = m_OuterCircle->Getx() + lngDiffX;
        lngCenterY = m_OuterCircle->Gety() + lngDiffY;
        
        // ~͑߂ɕ\
		m_disp->m_FvxDisplayEx->PutPenWidth( 2 );
        
        intCount = 0;
        for ( long i = 0 ; i <= 360 ; i =i + m_CheckCirclePitch ) {
            
            // O~̓_vZ
            x = lngCenterX + (m_OuterCircle->Getradius() * cos(i * PI / 180));
            y = lngCenterY + (m_OuterCircle->Getradius() * sin(i * PI / 180));
            
            // ϔZxlZo
            lngNowAveDensity = CalcAverage(x, y);
            
            // Zxl\
            pPoint->Putx( x );
            pPoint->Puty( y );
			str.Format("%d",lngNowAveDensity);
			m_disp->m_FvxDisplayEx->DrawText( 0, pPoint, _bstr_t(str));
            
            // ǔ۔
            if ((( m_StandardDensity[intCount] - m_CheckToleranceLevel) > lngNowAveDensity ) || (( m_StandardDensity[intCount] + m_CheckToleranceLevel ) < lngNowAveDensity )) {
                // ہ@FԂŌ~\  ~}[N\
				m_disp->m_FvxDisplayEx->PutPenColor( 0x0000FF );
                DrawCrossMark( x, y );
                lngNGCount = lngNGCount + 1;
			} else {
                // ǁ@FŌ~\
				m_disp->m_FvxDisplayEx->PutPenColor( 0xFF0000 );
			}
				
            // ~\
            pCheckCircle->Putx( x );
            pCheckCircle->Puty( y );
            pCheckCircle->Putradius( m_CheckCircleRadius );
			m_disp->m_FvxDisplayEx->DrawData( 0, pCheckCircle );
            
            intCount++;
		}
			    
		// ɖ߂
		m_disp->m_FvxDisplayEx->PutPenWidth( 1 );
        
	}
		
    // ԌvI
	double dblTime = 0;
    m_FvxPerformanceCounter->StopCount( &dblTime );
    str.Format(" : %.2fms\r\nmf : %d\r\n\r\n", dblTime , lngNGCount );
	m_result = str + m_result;
	UpdateData( FALSE );

}

// ~}[N\
CCircleAverageDlg::DrawCrossMark(long lng_x, long lng_y)
{

	IFvLineSegmentPtr pLineSeg(__uuidof( FvLineSegment ));
    
	pLineSeg->Putxs( lng_x - 5 );
	pLineSeg->Putys( lng_y - 5 );
	pLineSeg->Putxe( lng_x + 5 );
	pLineSeg->Putye( lng_y + 5 );
	m_disp->m_FvxDisplayEx->DrawData( 0, pLineSeg );
    
	pLineSeg->Putxs( lng_x - 5 );
	pLineSeg->Putys( lng_y + 5 );
	pLineSeg->Putxe( lng_x + 5 );
	pLineSeg->Putye( lng_y - 5 );
	m_disp->m_FvxDisplayEx->DrawData( 0, pLineSeg );

}

void CCircleAverageDlg::OnDosample() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// }X^摜ǂݍ
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

    CString str;
	str = szIniFilePath;
	str.Replace("CircleAverage.exe","sample1.bmp");
	m_FvxFileAccess->PutFilePath( _bstr_t( str ) );

    try {
		m_FvxFileAccess->LoadBitmap( m_FvxImage1 );
	} catch( _com_error ) {
		long lngErr = 0;
		m_FvxFileAccess->GetErrReport( &lngErr );
		MessageBox("sample1.bmpǂݍ߂܂ł" , "G[" , MB_ICONWARNING | MB_OK );
		return; 
	}

	m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
	m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );
	MessageBox("}X^摜ǂݍ" ,"", MB_ICONWARNING | MB_OK );
    
    // p^ǂݍ
    try {
		str = szIniFilePath;
		str.Replace("CircleAverage.exe","sample.pat");
		m_FvxPattern->PutLoadPattrenFileName( _bstr_t( str ) );
		m_FvxPattern->Load();
	} catch( _com_error ) {
		long lngErr = 0;
		m_FvxPattern->GetErrReport( &lngErr );
		MessageBox("sample.patǂݍ߂܂ł" , "G[" , MB_ICONWARNING | MB_OK );
		return; 
	}
		
    // O~ݒ
    m_OuterCircle->Putx( 192 );
    m_OuterCircle->Puty( 300 );
    m_OuterCircle->Putradius( 93 );
    
    // ʒu
    OnSetstandard();
	MessageBox("p^Ǎ݁" , "" , MB_ICONWARNING | MB_OK );
    
    // 摜ǂݍ
	str = szIniFilePath;
	str.Replace("CircleAverage.exe","sample2.bmp");
	m_FvxFileAccess->PutFilePath( _bstr_t( str ) );
    try {
	    m_FvxFileAccess->LoadBitmap( m_FvxImage1 );
	} catch( _com_error ) {
		long lngErr = 0;
		m_FvxFileAccess->GetErrReport( &lngErr );
		MessageBox("sample2.bmpǂݍ߂܂ł" , "G[" , MB_ICONWARNING | MB_OK );
		return; 
	}
    
	m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
	m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );
	MessageBox("摜ǂݍ" , "" ,  MB_ICONWARNING | MB_OK );
    
    // s
    OnExecute();
	MessageBox("ACgs" , "" ,  MB_ICONWARNING | MB_OK );

}

void CCircleAverageDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	// fBXvCJ
	if ( m_disp != NULL ) {
		m_disp->DestroyWindow();
		delete m_disp;
		m_disp = NULL;
	}

	// rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
	
}
