// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------
// SetCircleRobust.cpp : Cve[V t@C
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetCircleRobust _CAO


CSetCircleRobust::CSetCircleRobust(CWnd* pParent /*=NULL*/)
	: CDialog(CSetCircleRobust::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetCircleRobust)
	m_message = _T("");
	m_robustweight = 10;
	//}}AFX_DATA_INIT
}


void CSetCircleRobust::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetCircleRobust)
	DDX_Text(pDX, IDC_MESSAGE, m_message);
	DDX_Text(pDX, IDC_ROBUSTWEIGHT, m_robustweight);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetCircleRobust, CDialog)
	//{{AFX_MSG_MAP(CSetCircleRobust)
	ON_BN_CLICKED(IDC_CANCEL, OnCancel)
	ON_BN_CLICKED(IDC_ROBUST, OnRobust)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetCircleRobust bZ[W nh

BOOL CSetCircleRobust::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	//Ӂ
	// ߂COM̏sƂYȂłB
	CoInitialize( NULL );
	CWnd *pwnd ;
	IUnknown *p_unknown;

	// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
	pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );		// FvxDisplayEx̃nh擾
	p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
	p_unknown->QueryInterface( __uuidof(IFvxDisplayEx2Ptr) , (void**)&m_FvxDisplayEx );

	// eFvxRg[̃CX^X𐶐܂B
	m_FvxCalcData.CreateInstance( __uuidof( FvxCalcData ) ); 
	m_FvxImage1.CreateInstance( __uuidof( FvxImage ) ); 
	m_Circle.CreateInstance( __uuidof( FvCircle ) ); 

    m_PointNum = 0;
    m_blnIsSelecting = true;
    m_blnIsCircleSet = false;
    
	m_FvxImage1 = pFvxImageMain;
    m_FvxDisplayEx->CreateDisplay( 1 , 0 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );

    m_message = "w_ɑ΂ăoXgsAO~肵܂B\r\n~̓_RȏwAs{^Ă";

	UpdateData( FALSE );

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

// LZ
void CSetCircleRobust::OnCancel() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// LZ͖ݒԂɂďI
    m_blnIsCircleSet = false;
	EndDialog( IDCANCEL );
}

BEGIN_EVENTSINK_MAP(CSetCircleRobust, CDialog)
    //{{AFX_EVENTSINK_MAP(CSetCircleRobust)
	ON_EVENT(CSetCircleRobust, IDC_FVXDISPLAYEX1, 1 /* MouseDown */, OnMouseDownFvxdisplayex1, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

// _W̎w
void CSetCircleRobust::OnMouseDownFvxdisplayex1(long Button, long Shift, long X, long Y, long InOut) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    if ( m_blnIsSelecting ) {
    
        if ( m_PointNum < 100 ) {
            m_lngPointDataX[m_PointNum] = X;
            m_lngPointDataY[m_PointNum] = Y;
            
            DrawCrossMark( X, Y);
            
            m_PointNum = m_PointNum + 1;
        } else {
			MessageBox("100_ȏ͎wł܂","G[", MB_ICONWARNING | MB_OK);
		}
	}	
}

// ~}[N\܂
void CSetCircleRobust::DrawCrossMark(long lng_x, long lng_y)
{

	IFvLineSegmentPtr pLineSeg(__uuidof( FvLineSegment ));
    
    m_FvxDisplayEx->PutPenColor( 0xFF0000 );
    
    pLineSeg->Putxs( lng_x - 5 );
    pLineSeg->Putys( lng_y - 5 ); 
    pLineSeg->Putxe( lng_x + 5 ); 
    pLineSeg->Putye( lng_y + 5 ); 
    m_FvxDisplayEx->DrawData( 0, pLineSeg );
    
    pLineSeg->Putxs( lng_x - 5 );
    pLineSeg->Putys( lng_y + 5 );
    pLineSeg->Putxe( lng_x + 5 );
    pLineSeg->Putye( lng_y - 5 );
    m_FvxDisplayEx->DrawData( 0, pLineSeg );

}

// s
void CSetCircleRobust::OnRobust() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData( TRUE );
    
	m_blnIsSelecting = false;
    
	IFvPointPtr pPoint(__uuidof( FvPoint ));
	if ( m_PointNum >= 3 ) {
        
        // W_Zbg
        for ( long i = 0 ; i <= m_PointNum - 1 ; i++ ) {
            pPoint->Putx( m_lngPointDataX[i] );
            pPoint->Puty( m_lngPointDataY[i] );
            m_FvxCalcData->SetPoint( i, pPoint );
		}
			 
			try {
				// oXg̎s
				m_FvxCalcData->CalcCircle_Robust( m_PointNum, m_robustweight );

			} catch(_com_error ) {

				long lngErr = 0;
				m_FvxCalcData->GetErrReport( &lngErr );
				
				// G[oĂȂ`FbN
				MessageBox("oXgɎs܂B\r\nWf[^NA܂B","G[", MB_ICONWARNING | MB_OK);
				// Wf[^NAčĎw
				m_FvxDisplayEx->ClearOverlay( -1 );
				m_blnIsCircleSet = false;
				m_blnIsSelecting = true;
				m_PointNum = 0;
				return;
			}
        
			// ʂ擾
			m_FvxCalcData->CalcCircle_GetResult( m_Circle );
			m_FvxDisplayEx->DrawData( 0, m_Circle );
    
			if ( MessageBox("̌ʂŗǂłH","", MB_ICONQUESTION | MB_YESNO )==IDYES) {
				// ~肵Ã_CAOI
				m_blnIsCircleSet = true;
				EndDialog( IDCANCEL );
			} else {
				// Wf[^NAāAĎw
				m_FvxDisplayEx->ClearOverlay( -1 );
				m_blnIsCircleSet = false;
				m_blnIsSelecting = true;
				m_PointNum = 0;
			}
	} else {
		MessageBox("w_Ȃ܂B","G[", MB_ICONWARNING | MB_OK);
		m_blnIsSelecting = true;
	}
		
}
